if not _G.charSelectExists then return end
ACT_DASH = allocate_mario_action(ACT_GROUP_AIRBORNE|ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION|ACT_FLAG_ATTACKING|ACT_FLAG_AIR)
function act_dash (m)
    smlua_anim_util_set_animation(m.marioObj, "triplejump")
    mario_set_forward_vel(m, 60)
    local stepResult = perform_air_step(m, 0)
        if stepResult == AIR_STEP_LANDED then --hitting the gound
            return set_mario_action(m, ACT_BRAKING, 0)
        elseif m.wall then
        m.faceAngle.y = m.faceAngle.y * -60
            mario_bonk_reflection(m, true)
end
end
hook_mario_action(ACT_DASH, act_dash) 
function add_moveset()

-- a TON of coding help by the coop server, saul and charlie. thanks yall!

charSelect.character_hook_moveset(CT_KAKTUS, HOOK_BEFORE_SET_MARIO_ACTION,
function (m, inc)
local np = gNetworkPlayers[m.playerIndex]
if inc == ACT_WALL_KICK_AIR then
    return ACT_SIDE_FLIP
end
if inc == ACT_BACKFLIP_LAND then
    return ACT_LONG_JUMP_LAND
end
end)

function kaktus_update(m)
    --if m.action == ACT_DIVE and m.prevAction == ACT_WALKING then
        --set_mario_action(m, ACT_FORWARD_ROLLOUT, 0)
        --m.forwardVel = m.forwardVel * 1.2
        --m.faceAngle.y = m.intendedYaw
    --end
    if m.action == ACT_START_SLEEPING then
        set_mario_action(m, ACT_IDLE, 0)
    end
    if m.action == ACT_DIVE and mario_is_in_air_action(m) and m.prevAction ~= ACT_GROUND_POUND then
        set_mario_particle_flags(m, PARTICLE_VERTICAL_STAR, 0)
        set_mario_action(m, ACT_DASH, 0)
        m.forwardVel = m.forwardVel * 1.2
        m.faceAngle.y = m.intendedYaw
    end
    if m.action == ACT_JUMP and m.prevAction ~= ACT_FORWARD_ROLLOUT then
        set_mario_action(m, ACT_DOUBLE_JUMP, 0)
    end
    if m.marioObj.header.gfx.animInfo.animID == CHAR_ANIM_START_GROUND_POUND and m.controller.buttonPressed & B_BUTTON ~= 0 then
        set_mario_particle_flags(m, PARTICLE_VERTICAL_STAR, 0)
        set_mario_action(m, ACT_SLIDE_KICK, 0)
        m.forwardVel = m.forwardVel * 2
        m.faceAngle.y = m.intendedYaw 
        m.vel.y = m.vel.y * -5
    end
    if m.marioObj.header.gfx.animInfo.animID == CHAR_ANIM_GROUND_POUND and m.controller.buttonPressed & B_BUTTON ~= 0 then
        set_mario_particle_flags(m, PARTICLE_VERTICAL_STAR, 0)
        set_mario_action(m, ACT_SLIDE_KICK, 0)
        m.forwardVel = m.forwardVel * 2
        m.faceAngle.y = m.intendedYaw 
        m.vel.y = m.vel.y * -4
    end
    if m.action == ACT_BACKFLIP and m.prevAction == ACT_START_CROUCHING then
        set_mario_action(m, ACT_FORWARD_ROLLOUT, 0)
        m.forwardVel = m.forwardVel * -0.2
        m.faceAngle.y = m.intendedYaw
    end
    if m.action == ACT_SLIDE_KICK and m.pos.y == m.floorHeight then
        set_mario_action(m, ACT_SLIDE_KICK_SLIDE, 0)
    end
    if m.action == ACT_LONG_JUMP then
        set_mario_action(m, ACT_BACKFLIP, 0)
        m.forwardVel = m.forwardVel * -3
        m.faceAngle.y = m.intendedYaw
    end
    if m.action == ACT_DASH and m.controller.buttonPressed & Z_TRIG ~= 0 then
        set_mario_action(m, ACT_GROUND_POUND, 0)
    end
    if (m.action & ACT_GROUP_MASK) == ACT_GROUP_SUBMERGED then
        m.health = m.health - 1.5
    end
    if m.action == ACT_PUNCHING and m.prevAction == ACT_CROUCHING then
        set_mario_action(m, ACT_FORWARD_ROLLOUT, 0)
    end
    if m.action == ACT_MOVE_PUNCHING and m.prevAction == ACT_CROUCH_SLIDE then
        set_mario_action(m, ACT_FORWARD_ROLLOUT, 0)
    end
    if m.action == ACT_FORWARD_ROLLOUT and m.prevAction == ACT_SLIDE_KICK_SLIDE then
        set_mario_action(m, ACT_JUMP, 0)
    end
    if m.marioObj.header.gfx.animInfo.animID == CHAR_ANIM_BACKFLIP and m.marioObj.header.gfx.animInfo.animFrame == 0 then
        play_character_sound(m, CHAR_SOUND_YAHOO) 
    end
    if m.marioObj.header.gfx.animInfo.animID == CHAR_ANIM_SLIDE_KICK and m.marioObj.header.gfx.animInfo.animFrame == 0 then
        play_character_sound(m, CHAR_SOUND_PUNCH_HOO) 
    end
    if m.marioObj.header.gfx.animInfo.animID == CHAR_ANIM_FAST_LONGJUMP and m.marioObj.header.gfx.animInfo.animFrame == 0 then
        play_character_sound(m, CHAR_SOUND_SNORING1) 
    end
    if m.marioObj.header.gfx.animInfo.animID == CHAR_ANIM_SLOW_LONGJUMP and m.marioObj.header.gfx.animInfo.animFrame == 0 then
        play_character_sound(m, CHAR_SOUND_SNORING1) 
    end
    if m.action == ACT_DASH and m.marioObj.header.gfx.animInfo.animFrame == 0 then
        play_character_sound(m, CHAR_SOUND_IMA_TIRED)
    end
    --if m.prevAction == ACT_DIVE and m.action == ACT_FORWARD_ROLLOUT then 
    --    set_mario_particle_flags(m, ACTIVE_PARTICLE_V_STAR, 0)
    --end
end
_G.charSelect.character_hook_moveset(CT_KAKTUS, HOOK_MARIO_UPDATE, kaktus_update)
end